function VisuIlin(AC,mn,mx)
% VisuIlin: visualise linairement "l'intensit" d'une image en amplitude complexe.
% USAGE: VisuIlin(ImAC)  ou  VisuIlin(ImAC,min)  ou  VisuIlin(ImAC,min,max)
% ImAC:  matrice complexe contenant l'image en amplitude complexe
% min:  [OPTIONNEL] scalaire relle positif indiquant la valeur minimale reprsente par la LUT
%       (par dfaut, c'est la valeur minimale de |ImAC|.)
% max:  [OPTIONNEL] scalaire relle positif indiquant la valeur maximale reprsente par la LUT
%       (par dfaut, c'est la valeur maximale de |ImAC|.)
% Pour prciser la valeur  max  en utilisant la valeur  min  par dfaut, introduire [] pour min.
% 
%  Herv SAUER - SupOptique - 14 novembre 1997.
%


U=AC.*conj(AC);

if nargin < 2
   mn=min(min(U));
elseif isempty(mn)
   mn=min(min(U));
end

if nargin < 3
   mx=max(max(U));
elseif isempty(mx)
   mx=max(max(U));
end

figure(gcf),colormap(gray(256)),imagesc(U,[mn mx]),axis image,axis off
%colorbar




