% Main Script :
%Demo de calculs de psf,ftm, rapport de Srelh utilisant les polynmes de Zernicke
%
%L. Jacubowiez  Fev 98 - Maj Mars 2020 (Tltravail)
% %fichiers necessaires
%Zern_demo
%visuIlin
%VisuIdB
%Calc_phase_map
%Ne,Rapport_pupille_plan
%[Z,Ampl] variables globales
%PSF,Ampl_image aussi
%Lambda,foc,Dam_pupille,Rayon_pupille
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%premiere page
clear all;
close all;
g=figure;...
    set(g,'color',[0,0,0]);
set(g,'position',[10 10 750 555],'Resize','off');...
    set(gcf,'keyPressfcn','figure(gcf)');
a=axes;
set(a,'visible','off');

[LOGO,map]=imread('LogoLEnsE.jpg');
image(LOGO),colormap(map),axis('image'),set(gca,'vis','off')


t4=text(80,15,'******* DEMO ZERNICKE ********');
set(t4,'color','r');

t3=text(100,220,'L. JACUBOWIEZ     (Juin 1998 - mj: Mars 2020)');
set(t3,'color','g');

delete t3,t4
pbcont = uicontrol( gcf, ...			%cree un bouton pour la PSF
    'style','push',...
    'units','normalized',...
    'position',[0.2 0.1 0.2 0.05],...
    'string','Continuer');
waitforbuttonpress



clear all
close all
home
%valeurs par defaut
Ne=128;%Echantillonnage 128*128
Rapport_pupille_plan =4;
val_def_echant    = {'128','4'}; %pour la boite de dialogue



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Lambda=0.5*1e-3;%en mm HeNe
foc=100;
Diam_pupille=20;  %N=5, alpha'=0.1 rad
val_ini     = {'0.5','100','20'};  %pour la boite de dialogue
reponse_prec=val_ini;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% soit :
Rayon_pupille=Diam_pupille/2;
Rayon_image=Lambda*foc/(2*Rayon_pupille);

%flag PSF calcul
PSF_OK=0;
reponse_precedente={'0','0','0','0','0','0','0'};



%Tableau des Zernicke
Zern=zeros(1,36);
Zern_nuls=zeros(1,36);%pour la psf idale
quitter=0;
[Z,Ampl]=Calc_phase_map(Ne,Rapport_pupille_plan,Zern);
Ampl_image=fftshift(fft2(Ampl));
%calcul de l'intnsit dans le plan pupille
PSF=Ampl_image.*conj(Ampl_image);
Max_PSF_ideal=max(max(PSF));
PSF_ideal=PSF;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%debut boucle menu principal
while quitter~=1
    %menu principal
    rep_menu_principal=menu('Dmo Zernicke :    Menu principal',...
        'Objectif ideal','Aberrations du 3 ordre','Aberrations d''ordre suprieur',...
        'Dfaut du front d''onde','PSF',...
        'FTM','Focale, Pupille et longueur d''onde','Configuration','Quitter');

    %1'Objectif ideal'
    %2'ab. 3ordre'
    %3'ab. d'ordre sup
    %4'Dfaut front d''onde'
    %5'PSF'
    %6'FTM'
    %7'Focale,ect
    %8'Configuration'
    %9 quitter

    %111111%%%%objectif idal%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if rep_menu_principal==1
        Zern=zeros(1,36);      %remise  zeros des polynomes de Zernicke
        [Z,Ampl]=Calc_phase_map(Ne,Rapport_pupille_plan,Zern);
        close all
    end

    %22222222222%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %choix des aberrations du 3 ordre
    %et conversion Seidel vers Zernicke
    if rep_menu_principal==2


        val_ab=reponse_precedente;

        prompt  = {'Dfocalisation (en longueur d''onde)',...
            'Aberration sphrique (meilleur foyer)','Astigmatisme',...
            'Angle de l''astigmatisme en degr','Coma','Angle de la coma en degr', 'tilt'};
        %val_def     = {0,0,0,0,0,0};
        titre_dialogue   = ['3 ordre : carts normaux(en longueur d''onde)'];
        lineNo  = 1;
        reponses  = inputdlg(prompt,titre_dialogue,lineNo,val_ab);
        reponse_precedente=reponses;

        if size(reponses,1)~=0



            %defoc
            Seidel_defoc=str2num(reponses{1});
            C_Zer_defoc=Seidel_defoc/2;
            Zern(1,4)=C_Zer_defoc;

            %ab sphrique
            Seidel_abspher=str2num(reponses{2});
            C_Zer_abspher=Seidel_abspher/6;
            Zern(1,9)=C_Zer_abspher;

            %Astig
            Seidel_astig=str2num(reponses{3});
            Alpha=str2num(reponses{4});

            Alpha=pi*Alpha/180;
            C_Zer_4=Seidel_astig/(sqrt(2*1+(tan(2*Alpha))^2));
            C_Zer_5=C_Zer_4*tan(2*Alpha);

            Zern(1,5)=C_Zer_4;
            Zern(1,6)=C_Zer_5;

            %Coma
            Seidel_coma=str2num(reponses{5});
            Alpha=str2num(reponses{6});
            Alpha=pi*Alpha/180;
            C_Zer_6=Seidel_coma/(3*sqrt(1+(tan(Alpha))^2))
            C_Zer_7=C_Zer_6*tan(Alpha)
            Zern(1,7)=C_Zer_6;
            Zern(1,8)=C_Zer_7;
            %tilt
            Zern(1,2)=str2num(reponses{7});



        end
        close all
    end
    %%%%%%%%%%%fin menu ab 3ordre

    %33333333%%ab superieures
    if rep_menu_principal==3
        prompt  = {'Numro du polynme de Zernicke? (10  36): ','Ecart normal en longueur d''onde?'};
        val_def     = {'10','0'};
        titre_dialogue   = 'Polynmes de Zernicke d''ordre suprieur  8';
        lineNo  = 1;
        reponse  = inputdlg(prompt,titre_dialogue,lineNo,val_def);
        if size(reponse,1)~=0
            N_Zern=str2num(reponse{1});
            Zern(1, N_Zern)=str2num(reponse{2});
        end
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    %4444444 defaut du front d'onde
    if rep_menu_principal==4
        retourne_menuP=0;

        [Z_pupille,Ampl_pupille]=Calc_phase_map(Ne,1,Zern);

        while  retourne_menuP==0;
            menu_phase_map=menu('menu: Dfaut du front d''onde','3D','Contour','Coupe Ox','Coupe Oy','franges','menu principal');
            rotate3d off
            if menu_phase_map==1
                colormap('default')
                surf(Rayon_pupille*linspace(-1,1,Ne),Rayon_pupille*linspace(-1,1,Ne),Z_pupille)
                title(['Dfaut du front d''onde (en lambda)'])
                xlabel(['mm'])
                rotate3d
            end

            if menu_phase_map==2
                %colormap('default')
                contour(Rayon_pupille*linspace(-1,1,Ne),Rayon_pupille*linspace(-1,1,Ne),Z_pupille,20)
                axis image
                title(['Dfaut du front d''onde (en lambda)'])
                xlabel(['mm'])
            end

            if menu_phase_map==3
                %colormap('default')
                axis square
                plot(Rayon_pupille*linspace(-1,1,Ne),Z_pupille(Ne/2+1,1:Ne))
                title(['Dfaut du front d''onde (en lambda)'])
                xlabel(['mm'])
            end

            if menu_phase_map==4
                colormap('default')
                axis square
                plot(Rayon_pupille*linspace(-1,1,Ne),Z_pupille(1:Ne,Ne/2+1))
                title(['Dfaut du front d''onde (en lambda)'])
                xlabel(['mm'])
            end


            if menu_phase_map==5
                franges=cos(pi*2*Z_pupille);%config fizeau
                if (max(max(franges))-min(min(franges)) ) == 0 ,...
                        warndlg('Pas de franges (teinte plate) ! ','!! Warning !!')
                else
                    visuIlin(franges)
                    title('Config. Fizeau, Echantillonage pupille NexNe')
                    clear franges;
                end
            end

            if menu_phase_map==6
                retourne_menuP=1;
            end

        end
        clear Z_pupille Ampl_pupille;
    end

    %55555555  Calcul des PSF%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if rep_menu_principal==5
        retourne_menuP=0;
        %Ampl=masque.*exp(i*2*pi*Z);
        [Z,Ampl]=Calc_phase_map(Ne,Rapport_pupille_plan,Zern);
        %calcul de l'amplitude dans le plan pupille
        Ampl_image=fftshift(fft2(Ampl));
        %calcul de l'intnsit dans le plan pupille
        PSF=Ampl_image.*conj(Ampl_image);
        Max_PSF=max(max(PSF));
        PSF=PSF/Max_PSF;
        Rapport_de_Strelh=Max_PSF/Max_PSF_ideal;
        %titre des PSF
        str_Strehl=['PSF :        Strehl ratio =' num2str(Rapport_de_Strelh,3)];
        PSF_OK=1;%psf calcul
        while  retourne_menuP==0;
            menu_PSF=menu('Menu PSF','Niveau de gris','PSF 3D','Coupe X','Coupe Y','Defoc. (ecart_normal)','Defoc. (delta Z)','Menu principal');
            x_image=1e3*(Rayon_image/Rapport_pupille_plan )*(-Ne/2:+Ne/2-1); %axe de l'image echelle en microns
            rotate3d off
            if menu_PSF==1

                %PSF(niveau de gris)
                subplot(1,1,1)
                VisuIdB(Ampl_image,-30);
                title(str_Strehl)
                xlabel('Visualisation en dB  : seuil -30')
            end
            if menu_PSF==2
                subplot(1,1,1)
                colormap('default')
                surf(x_image,x_image,PSF)
                xlabel(['microns'])
                title(str_Strehl)
                rotate3d
            end
            if menu_PSF==4
                subplot(1,1,1)

                plot(x_image,PSF(:,Ne/2+1))
                title(str_Strehl)
                xlabel(['microns (coupe Oy)'])
            end

            if menu_PSF==3
                subplot(1,1,1)
                plot(x_image,PSF(Ne/2+1,:))
                xlabel(['microns (coupe Ox)'])
                title(str_Strehl)
            end


            if menu_PSF==5
                for Num_defoc=1:5
                    Zern(1,4)=(Num_defoc-3)/4;%pas de lambda/4
                    [Z,Ampl]=Calc_phase_map(Ne,Rapport_pupille_plan,Zern);
                    %calcul de l'amplitude dans le plan pupille
                    Ampl_image=fftshift(fft2(Ampl));
                    %calcul de l'intnsit dans le plan pupille
                    PSF=Ampl_image.*conj(Ampl_image);
                    Max_PSF=max(max(PSF));
                    PSF=PSF/Max_PSF;
                    subplot(1,5,Num_defoc)
                    VisuIdB(Ampl_image,-30);
                end
                subplot(1,5,3)
                delta_Z=(Lambda/4)/(1-cos(Rayon_pupille/foc));
                title(['1/4 Lambda, soit :' num2str(delta_Z,2) 'mm de dfoc. entre plans images'])

                Zern(1,4)=0;%on ramene defoc  zero

                %on doit recalculer la PSF
                [Z,Ampl]=Calc_phase_map(Ne,Rapport_pupille_plan,Zern);
                %calcul de l'amplitude dans le plan pupille
                Ampl_image=fftshift(fft2(Ampl));
                %calcul de l'intnsit dans le plan pupille
                PSF=Ampl_image.*conj(Ampl_image);
                Max_PSF=max(max(PSF));
                PSF=PSF/Max_PSF;
                Rapport_de_Strelh=Max_PSF/Max_PSF_ideal;
            end


            if menu_PSF==6

                %configuration echantillonage
                prompt  = {'Defoc. maximum en mm, par rapport au meilleur foyer?:'};
                val_def     = {'1'};%mm
                titre_dialogue   = 'Defocaliation : delta Z';
                lineNo  = 1;
                reponse  = inputdlg(prompt,titre_dialogue,lineNo,val_def);

                if size(reponse,1)~=0
                    delta_Z=str2num(reponse{1});
                    ecart_normal=delta_Z*(1-cos(Rayon_pupille/foc))/Lambda;%en lambda
                end
                for Num_defoc=1:5
                    Zern(1,4)= ecart_normal*(Num_defoc-3)/2;%pas de ecart_normal/2 en lambda
                    [Z,Ampl]=Calc_phase_map(Ne,Rapport_pupille_plan,Zern);
                    %calcul de l'amplitude dans le plan pupille
                    Ampl_image=fftshift(fft2(Ampl));
                    %calcul de l'intnsit dans le plan pupille
                    PSF=Ampl_image.*conj(Ampl_image);
                    Max_PSF=max(max(PSF));
                    PSF=PSF/Max_PSF;
                    subplot(1,5,Num_defoc)
                    VisuIdB(Ampl_image,-30);
                end
                subplot(1,5,3)
                %delta_Z=(Lambda/4)/(1-cos(Rayon_pupille/foc));
                title([num2str(delta_Z/2,2) 'mm de dfoc. entre plans images, soit un ecart normal :' num2str(ecart_normal/2,2) 'lambda'])

                Zern(1,4)=0;%on ramene defoc  zero
                %on doit recalculer la PSF
                [Z,Ampl]=Calc_phase_map(Ne,Rapport_pupille_plan,Zern);
                %calcul de l'amplitude dans le plan pupille
                Ampl_image=fftshift(fft2(Ampl));
                %calcul de l'intnsit dans le plan pupille
                PSF=Ampl_image.*conj(Ampl_image);
                Max_PSF=max(max(PSF));
                PSF=PSF/Max_PSF;
                Rapport_de_Strelh=Max_PSF/Max_PSF_ideal;
            end

            if menu_PSF==7
                retourne_menuP=1;
            end
        end %sous menu PSF
        close

    end




    %6666666    Calcul FTM%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if rep_menu_principal==6
        if PSF_OK==0 warndlg('Calculer la PSF d''abord!!','!! Warning !!')
        elseif PSF_OK==1
            retourne_menuP=0;
            %Calcul FTM

            FTM=abs(fftshift(fft2(PSF)));
            Max_FTM=max(max(FTM));
            FTM=FTM/Max_FTM;


            FTM_ideale=abs(fftshift(fft2(PSF_ideal)));
            Max_FTM_ideale=max(max(FTM_ideale));
            FTM_ideale=FTM_ideale/Max_FTM_ideale;


            f_coupure=1/(Lambda*foc/Diam_pupille);
            x_freq_3D=(Rapport_pupille_plan /Ne)*f_coupure*(-round(Ne/Rapport_pupille_plan ):round(Ne/Rapport_pupille_plan ));
            x_freq=(Rapport_pupille_plan/Ne)*f_coupure*(0:round(Ne/Rapport_pupille_plan ));

            while  retourne_menuP==0;
                menu_FTM=menu('Menu FTM','FTM 3D','Coupe X','Coupe Y','FTM en prsence de defoc','Menu principal');
                %x_image=1e3*(Rayon_image/Rapport_pupille_plan )*(-Ne/2:+Ne/2-1); %axe de l'image echelle en microns
                rotate3d off
                if menu_FTM==1
                    colormap('default')
                    surf(x_freq_3D,x_freq_3D,FTM(round(Ne/2-Ne/Rapport_pupille_plan ):round(Ne/2+Ne/Rapport_pupille_plan ),round(Ne/2-Ne/Rapport_pupille_plan ):round(Ne/2+Ne/Rapport_pupille_plan )))
                    xlabel(['mm^{-1}'])
                    title(['FTM'])
                    rotate3d

                end
                if menu_FTM==3
                    plot(x_freq,FTM(round(Ne/2+1):round(Ne/2+Ne/Rapport_pupille_plan )+1,Ne/2+1))
                    hold on
                    plot(x_freq,FTM_ideale(round(Ne/2+1):round(Ne/2+Ne/Rapport_pupille_plan )+1,Ne/2+1),'m--')
                    hold off
                    title(['FTM selon Oy'])
                    xlabel(['mm^{-1}'])
                end

                if menu_FTM==2
                    plot(x_freq,FTM(Ne/2+1,round(Ne/2+1):round(Ne/2+Ne/Rapport_pupille_plan )+1))
                    hold on
                    plot(x_freq,FTM_ideale(Ne/2+1,round(Ne/2+1):round(Ne/2+Ne/Rapport_pupille_plan )+1),'m--')
                    hold off
                    title(['FTM selon Ox'])
                    xlabel(['mm^{-1}'])
                end

                if menu_FTM==4

                    %configuration echantillonage
                    prompt  = {'Dfoc. maximum en mm, par rapport au meilleur foyer?:'};
                    val_def     = {'1'};%mm
                    titre_dialogue   = 'Dfocalisation : delta Z';
                    lineNo  = 1;
                    reponse  = inputdlg(prompt,titre_dialogue,lineNo,val_def);

                    if size(reponse,1)~=0
                        delta_Z=str2num(reponse{1});
                        ecart_normal=delta_Z*(1-cos(Rayon_pupille/foc))/Lambda;%en lambda
                    end

                    for Num_defoc=1:5
                        Zern(1,4)= ecart_normal*(Num_defoc-3)/4;%pas de ecart_normal/2 en lambda /2 pour passer an Zernicke
                        [Z,Ampl]=Calc_phase_map(Ne,Rapport_pupille_plan,Zern);
                        %calcul de l'amplitude dans le plan pupille
                        Ampl_image=fftshift(fft2(Ampl));
                        %calcul de l'intnsit dans le plan pupille
                        PSF=Ampl_image.*conj(Ampl_image);
                        Max_PSF=max(max(PSF));
                        PSF=PSF/Max_PSF;
                        %calcul de la ftm
                        FTM=abs(fftshift(fft2(PSF)));
                        Max_FTM=max(max(FTM));
                        FTM=FTM/Max_FTM;
                        subplot(2,5,Num_defoc)

                        plot(x_freq,FTM(round(Ne/2+1):round(Ne/2+Ne/Rapport_pupille_plan )+1,Ne/2+1))
                        hold on
                        plot(x_freq,FTM_ideale(round(Ne/2+1):round(Ne/2+Ne/Rapport_pupille_plan )+1,Ne/2+1),'m--')
                        hold off

                        subplot(2,5,5+Num_defoc)
                        plot(x_freq,FTM(Ne/2+1,round(Ne/2+1):round(Ne/2+Ne/Rapport_pupille_plan )+1))
                        hold on
                        plot(x_freq,FTM_ideale(Ne/2+1,round(Ne/2+1):round(Ne/2+Ne/Rapport_pupille_plan )+1),'m--')
                        hold off


                    end
                    subplot(2,5,3)
                    %delta_Z=(Lambda/4)/(1-cos(Rayon_pupille/foc));
                    title([num2str(delta_Z/2,2) 'mm de dfoc. entre plans images, soit un ecart normal :' num2str(ecart_normal/2,2) 'lambda'])
                    xlabel(['coupe Y'])

                    subplot(2,5,8)
                    xlabel(['coupe X'])

                    Zern(1,4)=0;%on ramene defoc  zero
                    %on doit recalculer la PSF
                    [Z,Ampl]=Calc_phase_map(Ne,Rapport_pupille_plan,Zern);
                    %calcul de l'amplitude dans le plan pupille
                    Ampl_image=fftshift(fft2(Ampl));
                    %calcul de l'intnsit dans le plan pupille
                    PSF=Ampl_image.*conj(Ampl_image);
                    Max_PSF=max(max(PSF));
                    PSF=PSF/Max_PSF;
                    Rapport_de_Strelh=Max_PSF/Max_PSF_ideal;
                end




                if menu_FTM==5
                    retourne_menuP=1;
                end
            end %du elseif
            PSF_OK=0;
            clear FTM,FTM_ideale;
        end %sous menu FTM
    end

    %77777%%%%%%%Config optique
    if rep_menu_principal==7
        %configuration optique
        val_opt=reponse_prec;
        prompt  = {'Entrer la longueur d''onde en microns','Entrer la focale en mm','Entrer le diamtre de la pupille en mm'};
        titre_dialogue   = 'Longueur d''onde et ouverture';
        lineNo  = 1;
        reponse  = inputdlg(prompt,titre_dialogue,lineNo,val_opt);
        reponse_prec=reponse;
        %Lambda
        if size(reponse,1)~=0  %cas annuler
            Lambda=str2num(reponse{1})%microns
            Lambda=1e-3*Lambda
            %en mm
            foc=str2num(reponse{2})
            %Diam_pupille en mm
            Diam_pupille=str2num(reponse{3})

            Rayon_pupille=Diam_pupille/2;
            Rayon_image=Lambda*foc/(2*Rayon_pupille);
            %on calcule PSF et FTM ideal par le script
            [Z,Ampl]=Calc_phase_map(Ne,Rapport_pupille_plan,Zern);
            Ampl_image=fftshift(fft2(Ampl));
            %calcul de l'intnsit dans le plan pupille
            PSF=Ampl_image.*conj(Ampl_image);
            Max_PSF_ideal=max(max(PSF));
        end
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    %888888 config echantillonnage%%%%%%%%%%%%%%%%%%%%%
    if rep_menu_principal==8
        %configuration echantillonage
        prompt  = {'Nombre d''chantillons, Ne?','Rapport : plan chantillonn/diamtre de la pupille (>2!) ?'};

        val_echant    =    val_def_echant;
        titre_dialogue   = 'Configuration de l''chantillonnage';
        lineNo  = 1;
        reponse  = inputdlg(prompt,titre_dialogue,lineNo,val_echant);
        val_def_echant =reponse;

        if size(reponse,1)~=0
            Ne=str2num(reponse{1});
            Rapport_pupille_plan =str2num(reponse{2});
            if Rapport_pupille_plan<=2
                Rapport_pupille_plan=2.1
                warndlg('Rapport plan/pupille doit tre ici > 2 !,le calcul est fait avec 2!','!! Warning !!')
            end


            %psf ideal
            [Z,Ampl]=Calc_phase_map(Ne,Rapport_pupille_plan,Zern_nuls);
            Ampl_image=fftshift(fft2(Ampl));
            %calcul de l'intnsit dans le plan pupille
            PSF=Ampl_image.*conj(Ampl_image);
            Max_PSF_ideal=max(max(PSF));
            PSF_ideal=PSF;
        end
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %9%%%%%%quitter%%%%%%%%%%%%%%%%%%%%%%%%
    if rep_menu_principal==9
        quitter=1;
        disp('C''est beau l''optique de Fourier!')
        disp('Au revoir et merci....')
        %quitter
    end

end %du while menu principal