% Main Script :
%Demo de calculs de speckle%
%   L. Jacubowiez  Mars 99
% % fichiers necessaires
%speckle_demo
%visuIlin 
%VisuIdB
%Visu_fft_dB
%speckle_phase
%masque_disque
%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Variables globales
%Ne,Rapport_pupille_plan
%stat_bruit (gaussien=1,equi=0)
%[Z,Ampl], Forme_pupille (masque)   variables globales
%PSF,Ampl_image aussi
%Rayon_pupille_pixel
%Lambda,foc,Dam_pupille,Rayon_relatif 
%rayon_correlation (pour les bruits non blanc)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%premiere page
clear all;
close all;
g=figure;...
   set(g,'color',[0,0,0]);
set(g,'position',[10 10 750 555],'Resize','off');...
set(gcf,'keyPressfcn','figure(gcf)');
a=axes;
set(a,'visible','off');

[LOGO,map]=imread('logo_so.tif');
image(LOGO),colormap(map),axis('image'),set(gca,'vis','off')

t4=text(80,15,'******* DEMO speckle ********');
set(t4,'color','r');

t3=text(100,270,'L. JACUBOWIEZ     (Mars 99)');
set(t3,'color','g');

delete t3,t4 
pbcont = uicontrol( gcf, ...			%cree un bouton pour la PSF
	'style','push',...
	'units','normalized',...
	'position',[0.2 0.1 0.2 0.05],...
	'string','Continuer');
waitforbuttonpress



clear all
close all
home
%valeurs par defaut
Ne=128;%Echantillonnage 128*128

Rapport_pupille_plan =3;  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Lambda=0.5*1e-3;%en mm HeNe
foc=100;
Diam_pupille=20;  %N=5, alpha'=0.1 rad
val_ini     = {'0.5','100','20'};  %pour la boite de dialogue
reponse_prec=val_ini;

Stat_bruit=0; %bruit equireparti par dfaut
rayon_correlation =0 %bruit blanc numrique
Bruit_phase=0;
reponse_precedente={'0'};%pas de bruit de phase par defaut
reponse_precedente_rayoncorr={'0'};

%flag : cas pupille double de pase identique! Flag=1
Ne_recalcul_pas_la_phase=0;

% soit :
Rayon_pupille=Diam_pupille/2;
Rayon_image=Lambda*foc/(2*Rayon_pupille);

%flag PSF calcul 


PSF_OK=0;
quitter=0;
[Z,Ampl]=phase_speckle(Ne,Rapport_pupille_plan,0,rayon_correlation );

Forme_pupille=ones(size(Ampl));
Ampl_image=fftshift(fft2(Forme_pupille.*Ampl));
%calcul de l'intnsit dans le plan pupille  
PSF=Ampl_image.*conj(Ampl_image);
Max_PSF_ideal=max(max(PSF));
PSF_ideal=PSF;



visuIdB(Ampl_image,-30);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%debut boucle menu principal
while quitter~=1
%menu principal
rep_menu_principal=menu('Dmo speckle:  Menu principal',...
   'Forme de la pupille',...%1
   'Phase nulle',...%2
   'Phase alatoire gaussienne',...%3
   'Phase equirpartie',...%4
   'Rayon de corrlation',...%5
   'Choix de pupille',...%6
   'Visualisation de la phase',...%7
   'Eclairement dans le plan image',...%8
   'Amplitude difffracte',...%9
   'FTM',...%10
   'Focale, Pupille et longueur d''onde',...%11
   'Configuration',...%12
   'Quitter');%13

%1forme pupille
%2Phase nulle(Objectif ideal)'
%3'Gaussienne'
%4'Equirpartie'
%5Rayon de corrlation
%6 choix de pupille
%7'Dfaut front d''onde'
%8'Amplitude'
%9'Eclairement'
%10'FTM
%11' Focale, Pupille,longueur d'onde
%12'Configuration'
%13'Quitter

%111111%%%%objectif idal%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if rep_menu_principal==2
   %remise  zeros de la phase 
   [Z,Ampl]=phase_speckle(Ne,Rapport_pupille_plan,0,rayon_correlation);
  end

%22222222222%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if rep_menu_principal==3
   
   
   bruit_gaussien_lambda=reponse_precedente;
   
   prompt  = ('Ecart type en Lambda');
   titre_dialogue   = ['Bruit Gaussien : Ecart normal en longueur d''onde)'];
   lineNo  = 1;
   reponse  = inputdlg(prompt,titre_dialogue,lineNo,bruit_gaussien_lambda);
   reponse_precedente=reponse;
   
   if size(reponse,1)~=0
      Bruit_phase=str2num(reponse{1});
      Stat_bruit=1;%bruit gaussien
   end
   close all
end    

%%%%%%%%%%%fin gaussienne

%4%equireparti
if rep_menu_principal==4
    bruit_lambda=reponse_precedente;
    prompt  = ('Bruit quirparti : Ecart normal maximum')
    titre_dialogue   = ['Ecart normal en longueur d''onde)'];
    lineNo  = 1;
    reponse  = inputdlg(prompt,titre_dialogue,lineNo,bruit_lambda);
    reponse_precedente=reponse;
   
   if size(reponse,1)~=0
      Bruit_phase=str2num(reponse{1});
      
      Stat_bruit=0;%bruit uniforme
   end
   close all
  end
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %5% Rayon correlation
  if rep_menu_principal==5
    str_rayon_correlation=reponse_precedente_rayoncorr;
    prompt  = ('Rayon de correlation (0 pour un bruit blanc numrique)(maximum:5)?');
    titre_dialogue   = ['Valeur du rayon de corrlation du modulateur de phase'];
    lineNo  = 1;
    reponse  = inputdlg(prompt,titre_dialogue,lineNo,str_rayon_correlation);
    reponse_precedente_rayoncorr=reponse;
    
    if size(reponse,1)~=0
      rayon_correlation=str2num(reponse{1});
    end
    close all
  end
  
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %6%%%%%%%%%%%%%%%%Choix de pupille
  
  if rep_menu_principal==6
    retourne_menuP=0;
    %Ampl=masque.*exp(i*2*pi*Z);
    Ne_recalcul_pas_la_phase=0;

    if Stat_bruit==0,
      [Z,Ampl]=phase_speckle(Ne,Rapport_pupille_plan, Bruit_phase,rayon_correlation );
    end
    
    if Stat_bruit==1, %cas Gaussien
      [Z,Ampl]=phase_speckle(Ne,Rapport_pupille_plan, Bruit_phase,rayon_correlation,1);
    end
    
    
    %affichage de la pupille actuelle
    colormap('gray')
    imagesc(angle(Ampl)),axis image,axis off,colorbar
    title(['Dfaut du front d''onde (en radian)'])

    
    
    while  retourne_menuP==0;
      menu_pupille=menu('menu: Choix de pupille','Pupille par dfaut','Disque','Pupille rectangulaire','Pupille polygonale','Pupille double (non corrles)','Pupille double (mme phase)' ,'menu principal');
      if menu_pupille==1
      end
      
      if menu_pupille==2
        rayon_relatif=1;    
        str_rayon_relatif={num2str(rayon_relatif,3)};
        prompt  = ('Rayon de la pupille (0<R<1) ?');
        titre_dialogue   = ['Rayon pupille/Rayon pupille maximum'];
        lineNo  = 1;
        reponse  = inputdlg(prompt,titre_dialogue,lineNo,str_rayon_relatif);
        
        if size(reponse,1)~=0
          rayon_relatif=str2num(reponse{1});
        end
        Forme_pupille=masque_disque(Ne,Rapport_pupille_plan,rayon_relatif);
        imagesc( Forme_pupille.*angle(Ampl)),axis image,axis off,colorbar
        title(['Dfaut du front d''onde (en radian)'])
      
      end
      
 %pupille rectangulaire        
      if menu_pupille==3
        largeur_relatif=1;    
        longueur_relatif=1;
        str_largeur_relatif={num2str(largeur_relatif,3),num2str(longueur_relatif,3)};
        prompt  = {'Largeur pupille (0<Largeur<1) ?','Longueur pupille (0<Longeur<1) ?'};
        
        titre_dialogue   = ['Dimension du rectangle'];
        lineNo  = 1;
        reponse  = inputdlg(prompt,titre_dialogue,lineNo,str_largeur_relatif);
        
        if size(reponse,1)~=0
          largeur_relatif=str2num(reponse{1});
           longueur_relatif=str2num(reponse{2});
        end
        Forme_pupille=masque_disque(Ne,Rapport_pupille_plan,largeur_relatif,longueur_relatif);
        imagesc( Forme_pupille.*angle(Ampl)),axis image,axis off,colorbar
        title(['Dfaut du front d''onde (en radian)'])
        
       
      end
      
      %Pupille polygonale
      if menu_pupille==4
        hbox=helpdlg('Slectionner le polygne  la souris (par le click gauche et click droit pour finir)','Zone d''interfrence polygonale');
        waitforbuttonpress
        Forme_pupille=double(roipoly);
        imagesc( Forme_pupille.*angle(Ampl)),axis image,axis off,colorbar
        title(['Dfaut du front d''onde (en radian)'])
      end  
      
      %Pupille double
      
      if menu_pupille==5
         %hbox=helpdlg('');
         %waitforbuttonpress
         %Forme_pupille=double(roipoly);
         Forme_pupille1=masque_disque(Ne,Rapport_pupille_plan,0.4 );
        % Forme_pupille2=masque_disque(Ne,Rapport_pupille_plan,0.4 );
          Forme_pupille2= Forme_pupille1;
         
         decal_h=Forme_pupille1(:,1:14);
         decal_v=Forme_pupille1(1:14,:);
         
         Forme_pupille1=[Forme_pupille1(:,15:Ne) decal_h];
         Forme_pupille2=[decal_h Forme_pupille2(:,1:Ne-14) ];
         Forme_pupille1=[Forme_pupille1(15:Ne,:);decal_v];
         Forme_pupille2=[decal_v;Forme_pupille2(1:Ne-14,:)];
         Forme_pupille=Forme_pupille1+Forme_pupille2;
         
         
      imagesc( Forme_pupille.*angle(Ampl)),axis image,axis off,colorbar
      title(['Dfaut du front d''onde (en radian)'])
         
         clear Forme_pupille1
         clear Forme_pupille2
         clear decal
      end  
      
      
         
      if menu_pupille==6
         %hbox=helpdlg('');
         %waitforbuttonpress
         %Forme_pupille=double(roipoly);
         
         Forme_pupille1=Ampl.*masque_disque(Ne,Rapport_pupille_plan,0.4 );
        % Forme_pupille2=masque_disque(Ne,Rapport_pupille_plan,0.4 );
          Forme_pupille2= Forme_pupille1;
         
         decal_h=Forme_pupille1(:,1:14);
         decal_v=Forme_pupille1(1:14,:);
         
         Forme_pupille1=[Forme_pupille1(:,15:Ne) decal_h];
         Forme_pupille2=[decal_h Forme_pupille2(:,1:Ne-14) ];
         Forme_pupille1=[Forme_pupille1(15:Ne,:);decal_v];
         Forme_pupille2=[decal_v;Forme_pupille2(1:Ne-14,:)];
         Ampl=Forme_pupille1+Forme_pupille2;
         
         
      imagesc( angle(Ampl)),axis image,axis off,colorbar
      title(['Dfaut du front d''onde (en radian)'])
         
         clear Forme_pupille1
         clear Forme_pupille2
         clear decal
         
         Ne_recalcul_pas_la_phase=1;
      end  
      
      
      
      
      
      
      if menu_pupille==7
        retourne_menuP=1;
      end
     
    end
    
    
  end
  
  
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  
  
  
  
  
  



%6 defaut du front d'onde
if rep_menu_principal==7   retourne_menuP=0;
   if Stat_bruit==0,
      [Z_pupille,Ampl_pupille]=phase_speckle(Ne,1, Bruit_phase,rayon_correlation);
   end
   
   if Stat_bruit==1, %cas Gaussien
      [Z_pupille,Ampl_pupille]=phase_speckle(Ne,1, Bruit_phase,rayon_correlation,1);
   end
  Z_pupille=rem(Z_pupille,pi);%calculer entre pi et -pi
   
   
   while  retourne_menuP==0;
      menu_phase_map=menu('menu: Dfaut du front d''onde','Niveau de gris','Coupe Ox','Coupe Oy','3D','histogramme des phase','autocorrlation','menu principal');
      if menu_phase_map==1
         colormap('gray')
         Z_pupille=rem(Z_pupille,pi);
         imagesc(Z_pupille,[-pi,pi]),axis image,axis off,colorbar
         title(['Dfaut du front d''onde (en radian) : std=' num2str(Bruit_phase,2) ', rc=' num2str(rayon_correlation,2)])
         
         
      end
      
             
       if menu_phase_map==2
          %colormap('default')
          axis square
          plot(Rayon_pupille*linspace(-1,1,Ne),Z_pupille(Ne/2+1,1:Ne))
          title(['Dfaut du front d''onde (en lambda)'])
           Xlabel([ 'Phase : std=' num2str(Bruit_phase,2) ', rc=' num2str(rayon_correlation,2) ]) 
       end

       if menu_phase_map==3
          colormap('default')
          axis square
          plot(Rayon_pupille*linspace(-1,1,Ne),Z_pupille(1:Ne,Ne/2+1))
          title(['Dfaut du front d''onde (en lambda)'])
           Xlabel([ 'Phase : std=' num2str(Bruit_phase,2) ', rc=' num2str(rayon_correlation,2) ]) 
       end
       if menu_phase_map==4
          rotate3d
          colormap('default')
          surf(Z_pupille)
          title([ 'Phase : std=' num2str(Bruit_phase,2) ', rc=' num2str(rayon_correlation,2) ]) 
        end  
        if menu_phase_map==5
           
           phase=reshape(Z_pupille,Ne*Ne,1);
           [histophase,X]=hist(phase,linspace(-pi,pi,255));
           figure,bar(X,histophase)
           Xlabel([ 'Phase : std=' num2str(Bruit_phase,2) ', rc=' num2str(rayon_correlation,2) ]) 
           clear phase X histophase
        end     
        if menu_phase_map==6
           
           hbox=warndlg('Patience, c''est  un peu long!','Cliquer sur OK pour continuer');
           waitforbuttonpress
           Autocorr=xcorr2(Z_pupille);
           subplot(2,2,1)
           colormap('default'),imagesc(Autocorr),axis equal
           
           subplot(2,2,4)
           colormap('default'),surf(Autocorr(Ne-10:Ne+10,Ne-10:Ne+10))
           
           subplot(2,2,2)
           plot((-Ne+1:Ne-1),Autocorr(:,Ne)),grid on,axis tight
           zoom on

           subplot(2,2,3)
           plot((-Ne+1:Ne-1),Autocorr(Ne,:)),grid on,axis tight
           zoom on
           %clear Autocorr
           
           
           
        end
        
        if menu_phase_map==7
           retourne_menuP=1;
        end
        
    end 
    close all
 % clear Z_pupille Ampl_pupille;
end





%88888888888  Calcul des PSF%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if rep_menu_principal==8
   retourne_menuP=0;
   %Ampl=masque.*exp(i*2*pi*Z);
   if Ne_recalcul_pas_la_phase==0
      
      if Stat_bruit==0,
         [Z,Ampl]=phase_speckle(Ne,Rapport_pupille_plan, Bruit_phase,rayon_correlation );
      end
      
      if Stat_bruit==1, %cas Gaussien
         [Z,Ampl]=phase_speckle(Ne,Rapport_pupille_plan, Bruit_phase,rayon_correlation,1);
      end
   end
   str_Strehl=[ 'Phase : std=' num2str(Bruit_phase,2) ', rc=' num2str(rayon_correlation,2) ]
   
   
   
   
%calcul de l'amplitude dans le plan pupille  
Ampl_image=fftshift(fft2(Forme_pupille.*Ampl));
%calcul de l'eclairement dans le plan pupille  
PSF=Ampl_image.*conj(Ampl_image);
Max_PSF=max(max(PSF));
PSF=PSF/Max_PSF;
Rapport_de_Strelh=Max_PSF/Max_PSF_ideal;
%titre des PSF
str_Strehl=[ 'Phase : std=' num2str(Bruit_phase,2) ', rc=' num2str(rayon_correlation,2) '.  PSF : Strehl Ratio =' num2str(Rapport_de_Strelh,3)];
 PSF_OK=1;%psf calcul
    while  retourne_menuP==0;
       menu_PSF=menu('Menu PSF','Niveau de gris','PSF 3D','Coupe X','Coupe Y','histogramme','Deux speckles incohrents','Menu principal');
       x_image=1e3*(Rayon_image/Rapport_pupille_plan )*(-Ne/2:+Ne/2-1); %axe de l'image echelle en microns
		rotate3D off	
       if menu_PSF==1
          
            %PSF(niveau de gris)
            subplot(1,1,1)
            visuIdB(Ampl_image,-30);
            title(str_Strehl)
            xlabel('Visualisation en dB  : seuil -30')
         end
         
        if menu_PSF==2
           subplot(1,1,1)
           colormap('default')
           surf(x_image,x_image,PSF)
           xlabel(['microns'])
           title(str_Strehl)
           rotate3D
        end
        if menu_PSF==3
           subplot(1,1,1)
           plot(x_image,PSF(Ne/2+1,:))
           xlabel(['microns (coupe Ox)'])
           title(str_Strehl)                       
        end
        

        if menu_PSF==4
           subplot(1,1,1)
           
           plot(x_image,PSF(:,Ne/2+1))
           title(str_Strehl)
           xlabel(['microns (coupe Oy)'])
        end
        
          
        if menu_PSF==5
          PSF_col=reshape(PSF,Ne*Ne,1);
          [histoPSF,X]=hist(PSF_col,linspace(0,1,255));
          figure,bar(X,histoPSF/max(histoPSF)) %normalis  un
          hold on
          Im=(X*histoPSF')/sum(histoPSF')
          std_I=std(PSF_col);
           title(['Eclairement moyen=' num2str(Im,2) ',  Ecart type  = '  num2str(std_I,2) ' RSB = ' num2str(Im/std_I,2)])
          Xlabel('Histogramme et courbe (1/Im)exp(-I/Im)')
          plot(X,exp(-X./Im),'r')
          axis([0 1 0 1])
          line([0 1],[exp(-1) exp(-1)])
          line([Im Im],[0 1])
          
                zoom on

          hold off
          
         % clear X histoPSF PSF_col Im 
          
          
       end
       
       
       if menu_PSF==6
          close all
          if Stat_bruit==0,
             [Z,Ampl]=phase_speckle(Ne,Rapport_pupille_plan, Bruit_phase,rayon_correlation );
          end
          
          if Stat_bruit==1, %cas Gaussien
             [Z,Ampl]=phase_speckle(Ne,Rapport_pupille_plan, Bruit_phase,rayon_correlation,1);
          end
          
          %calcul de l'amplitude dans le plan pupille  
          Ampl_image=fftshift(fft2(Forme_pupille.*Ampl));
          %calcul de l'eclairement dans le plan pupille  
          PSF=Ampl_image.*conj(Ampl_image);
          %%%%%%%%premier speckle
          
          if Stat_bruit==0,
             [Z,Ampl]=phase_speckle(Ne,Rapport_pupille_plan, Bruit_phase,rayon_correlation );
          end
          
          if Stat_bruit==1, %cas Gaussien
             [Z,Ampl]=phase_speckle(Ne,Rapport_pupille_plan, Bruit_phase,rayon_correlation,1);
          end
          
          %calcul de l'amplitude dans le plan pupille  
          Ampl_image=fftshift(fft2(Forme_pupille.*Ampl));
          
          
          PSF=PSF+Ampl_image.*conj(Ampl_image);
          %%%%%%%%On ajoute le 2eme speckle
          Max_PSF=max(max(PSF));
          PSF=PSF/Max_PSF;
          Rapport_de_Strelh=Max_PSF/Max_PSF_ideal;
          %titre des PSF
          %str_Strehl=[ 'Phase : std=' num2str(Bruit_phase,2) ', rc=' num2str(rayon_correlation,2) '.  PSF : Strehl Ratio =' num2str(Rapport_de_Strelh,3)];
          PSF_OK=1;%psf calcul
          subplot(2,1,1)   
          Visu_fft_dB(PSF,-30);
          %%%%%%%%%%%%%%%%%%%%histo
          subplot(2,1,2)  
          PSF_col=reshape(PSF,Ne*Ne,1);
          [histoPSF,X]=hist(PSF_col,linspace(0,1,255));
          %figure
          bar(X,histoPSF/max(histoPSF)) %normalis  un
          hold on
          Im=(X*histoPSF')/sum(histoPSF')
          std_I=std(PSF_col);
          title(['Eclairement moyen=' num2str(Im,2) ',     Ecart type  = '  num2str(std_I,2) '    RSB = ' num2str(Im/std_I,3)])
          Xlabel('Histogramme et courbe (I/Im^2)exp(-I/Im)')
          I2m=Im/2;
                   plot(X,(X./I2m^2).*exp(-X./I2m)./max((X/I2m^2).*exp(-X./I2m)),'r')
          axis([0 1 0 1])
          %line([0 1],[exp(-1) exp(-1)])
          line([Im Im],[0 1])

           zoom on
          
          hold off
          
          % clear X histoPSF PSF_col Im 
          
          
       end
       
       
       
       
       if menu_PSF==7
          retourne_menuP=1;
        end
     end %sous menu PSF         
     close all
     
  end
  %%%%%%%%%%%%%%%%%%%Amplitude%%%%%%%%%%%%%%%%%%%%%%%%
%99999999999999999999999%%%%%%%%Amplitude image%%%%%%%%%%%%%%%%%%%%%%%
if rep_menu_principal==9
   retourne_menuP=0;
   if Ne_recalcul_pas_la_phase==0
      
      if Stat_bruit==0,
         [Z,Ampl]=phase_speckle(Ne,Rapport_pupille_plan, Bruit_phase,rayon_correlation );
      end
      
      if Stat_bruit==1, %cas Gaussien
         [Z,Ampl]=phase_speckle(Ne,Rapport_pupille_plan, Bruit_phase,rayon_correlation,1);
      end
   end
   %calcul de l'amplitude dans le plan pupille  
   Ampl_image=fftshift(fft2(fftshift(Forme_pupille.*Ampl)));
   
   
   
   while  retourne_menuP==0;
      menu_Ampl=menu('Menu Amplitude Image','module','phase','Menu principal');
      x_image=1e3*(Rayon_image/Rapport_pupille_plan )*(-Ne/2:+Ne/2-1); %axe de l'image echelle en microns
      rotate3D off	
      if menu_Ampl==1
         
         %PSF(niveau de gris)
         subplot(1,1,1)
         Visu_fft_dB(abs(Ampl_image),-30);
         title('Module')
         xlabel('Visualisation en dB  : seuil -30')
      end
      
      if menu_Ampl==2
         subplot(1,1,1)
         colormap('default')
         VisuPh(Ampl_image)
         xlabel(['microns'])
         title('phase')
      end
      
      if menu_Ampl==3
         retourne_menuP=1;
      end
      
   end
   
   
end  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  %1010101010  Calcul FTM%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  if rep_menu_principal==10
     if PSF_OK==0 warndlg('Calculer la PSF d''abord!!','!! Warning !!')
     elseif PSF_OK==1
     retourne_menuP=0;
     %Calcul FTM
     
   FTM=abs(fftshift(fft2(PSF)));
   Max_FTM=max(max(FTM));
   FTM=FTM/Max_FTM;
   
      
   FTM_ideale=abs(fftshift(fft2(PSF_ideal)));
   Max_FTM_ideale=max(max(FTM_ideale));
   FTM_ideale=FTM_ideale/Max_FTM_ideale;

   
   f_coupure=1/(Lambda*foc/Diam_pupille);
   x_freq_3D=(Rapport_pupille_plan /Ne)*f_coupure*(-round(Ne/Rapport_pupille_plan ):round(Ne/Rapport_pupille_plan ));
   x_freq=(Rapport_pupille_plan/Ne)*f_coupure*(0:round(Ne/Rapport_pupille_plan ));
   
    while  retourne_menuP==0;
       menu_FTM=menu('Menu FTM','FTM 3D','Coupe X','Coupe Y','Menu principal');
       %x_image=1e3*(Rayon_image/Rapport_pupille_plan )*(-Ne/2:+Ne/2-1); %axe de l'image echelle en microns
				rotate3D off
         if menu_FTM==1
            colormap('default')
            surf(x_freq_3D,x_freq_3D,FTM(round(Ne/2-Ne/Rapport_pupille_plan ):round(Ne/2+Ne/Rapport_pupille_plan ),round(Ne/2-Ne/Rapport_pupille_plan ):round(Ne/2+Ne/Rapport_pupille_plan )))
            xlabel(['mm^{-1}'])
            title(['FTM'])
            rotate3D
            
         end
        if menu_FTM==3
           plot(x_freq,FTM(round(Ne/2+1):round(Ne/2+Ne/Rapport_pupille_plan )+1,Ne/2+1))
           hold on
           plot(x_freq,FTM_ideale(round(Ne/2+1):round(Ne/2+Ne/Rapport_pupille_plan )+1,Ne/2+1),'m--')
           hold off
           title(['FTM selon Oy'])
           xlabel(['mm^{-1}'])
            end

       if menu_FTM==2 
               plot(x_freq,FTM(Ne/2+1,round(Ne/2+1):round(Ne/2+Ne/Rapport_pupille_plan )+1))
               hold on
               plot(x_freq,FTM_ideale(Ne/2+1,round(Ne/2+1):round(Ne/2+Ne/Rapport_pupille_plan )+1),'m--')
               hold off
               title(['FTM selon Ox'])
               xlabel(['mm^{-1}'])
        end
            
              
            
            
            if menu_FTM==4
               retourne_menuP=1;
            end
         end %du elseif
         PSF_OK=0;
         clear FTM,FTM_ideale;
     end %sous menu FTM         
  end
  
%77777%%%%%%%Config optique
if rep_menu_principal==11   %configuration optique
   val_opt=reponse_prec;
   prompt  = {'Entrer la longueur d''onde en microns','Entrer la focale en mm','Entrer le diamtre de la pupille en mm'};
   titre_dialogue   = 'Longueur d''onde et ouverture';
   lineNo  = 1;
   reponse  = inputdlg(prompt,titre_dialogue,lineNo,val_opt);
   reponse_prec=reponse;
   %Lambda
   if size(reponse,1)~=0  %cas annuler
      Lambda=str2num(reponse{1})%microns
      Lambda=1e-3*Lambda
      %en mm
      foc=str2num(reponse{2})
      %Diam_pupille en mm
      Diam_pupille=str2num(reponse{3})
      
      Rayon_pupille=Diam_pupille/2;
      Rayon_image=Lambda*foc/(2*Rayon_pupille);
      %on calcule PSF et FTM ideal par le script
      [Z,Ampl]=phase_speckle(Ne,Rapport_pupille_plan,Bruit_phase,rayon_correlation );
    
      Ampl_image=fftshift(fft2(Forme_pupille.*Ampl));
      %calcul de l'intnsit dans le plan pupille  
      PSF=Ampl_image.*conj(Ampl_image);
      Max_PSF_ideal=max(max(PSF));
   end
  end
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  %888888 config echantillonnage%%%%%%%%%%%%%%%%%%%%%
  if rep_menu_principal==12
     %configuration echantillonage
   prompt  = {'Nombre d''chantillons, Ne?','Rapport : plan chantillonn/diamtre de la pupille ?'};
   val_def     = {'128','4'};
   titre_dialogue   = 'Configuration de l''chantillonnage';
   lineNo  = 1;
   reponse  = inputdlg(prompt,titre_dialogue,lineNo,val_def);
   
   if size(reponse,1)~=0
      Ne=str2num(reponse{1});
      Rapport_pupille_plan =str2num(reponse{2});
      %psf ideal   
      [Z,Ampl]=phase_speckle(Ne,Rapport_pupille_plan, Bruit_phase,rayon_correlation );

      Ampl_image=fftshift(fft2(Forme_pupille.*Ampl));
      %calcul de l'intnsit dans le plan pupille  
      PSF=Ampl_image.*conj(Ampl_image);
      Max_PSF_ideal=max(max(PSF));
      PSF_ideal=PSF; 
   end
end   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%9%%%%%%quitter%%%%%%%%%%%%%%%%%%%%%%%%
if rep_menu_principal==13
   quitter=1;
   disp('C''est beau l''optique de Fourier!')
   disp('Au revoir et merci....')
   %quitter
end

end %du while menu principal